$title input data

Set
   i 'station'
   j 'date'
   k 'time'
   t 'type'   / type1*type3 / 
   w 'windspeed'
*  in this example i,j,k,w are implictly declared    
   speed(i<,j<,k<,w<)   
;

Parameter
speedPar(i,j,k)       'Speed'
power_wind(t,w)       'Power assigned to windspeed'
power_output(i,j,k,t) 'Power output at every meassuring point for each type'
;

$onechoV > readStationData.gms
file load / loadGDX.inc /;
set f files / 1*%NBFILES%/;
loop(f,
  put_utility 'exec' / 'csv2gdx station' f.tl:0 '.txt output=station' f.tl:0 '.gdx id=speed fieldSep=semiColon index=1,2,3,5 useHeader=y storeZero=y'
  abort$(errorlevel<>0) 'probem running csv2gdx via put utility'
  put load '$gdxin station' f.tl:0 '.gdx' /
           '$load speed'                  /
           '$gdxin'                       /;
);
putclose;

$offecho

$call gams readStationData.gms lo=%gams.lo% --NBFILES=5
$ife errorlevel<>0 $abort problem running readStationData.gms
$onMulti
$include loadGDX.inc

*make up some random wind data
power_wind(t,w) = uniform(0,100)*w.val;
*store wind data also as parameter to show how slow this when calculating power_output
speedPar(i,j,k) = sum(speed(i,j,k,w), w.val);

* turn on profiling (https://www.gams.com/latest/docs/UG_GamsCall.html#GAMSAOprofile)
option profile=1;

* compute power_output with windspeed parameter (SLOW)
power_output(i,j,k,t) = sum(w$[abs(w.val-speedPar(i,j,k))<1e-6], power_wind(t,w));
option clear=power_output;
* compute power output with windspeed as set (FAST)
power_output(i,j,k,t) = sum(speed(i,j,k,w), power_wind(t,w));

* display data
*option  speed:0:0:1;
*display i,j,k,w,t,speed,power_output;

